"""
    Bandwidth

    Bandwidth's Communication APIs  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: letstalk@bandwidth.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bandwidth.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from bandwidth.exceptions import ApiAttributeError


def lazy_import():
    from bandwidth.model.callback_method_enum import CallbackMethodEnum
    globals()['CallbackMethodEnum'] = CallbackMethodEnum


class CreateCallResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('username',): {
            'max_length': 1024,
        },
        ('password',): {
            'max_length': 1024,
        },
        ('fallback_username',): {
            'max_length': 1024,
        },
        ('fallback_password',): {
            'max_length': 1024,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'application_id': (str,),  # noqa: E501
            'account_id': (str,),  # noqa: E501
            'call_id': (str,),  # noqa: E501
            'to': (str,),  # noqa: E501
            '_from': (str,),  # noqa: E501
            'call_url': (str,),  # noqa: E501
            'answer_method': (CallbackMethodEnum,),  # noqa: E501
            'answer_url': (str,),  # noqa: E501
            'disconnect_method': (CallbackMethodEnum,),  # noqa: E501
            'enqueued_time': (datetime, none_type,),  # noqa: E501
            'call_timeout': (float,),  # noqa: E501
            'callback_timeout': (float,),  # noqa: E501
            'tag': (str, none_type,),  # noqa: E501
            'answer_fallback_method': (CallbackMethodEnum,),  # noqa: E501
            'answer_fallback_url': (str, none_type,),  # noqa: E501
            'disconnect_url': (str, none_type,),  # noqa: E501
            'username': (str, none_type,),  # noqa: E501
            'password': (str, none_type,),  # noqa: E501
            'fallback_username': (str, none_type,),  # noqa: E501
            'fallback_password': (str, none_type,),  # noqa: E501
            'priority': (float, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'application_id': 'applicationId',  # noqa: E501
        'account_id': 'accountId',  # noqa: E501
        'call_id': 'callId',  # noqa: E501
        'to': 'to',  # noqa: E501
        '_from': 'from',  # noqa: E501
        'call_url': 'callUrl',  # noqa: E501
        'answer_method': 'answerMethod',  # noqa: E501
        'answer_url': 'answerUrl',  # noqa: E501
        'disconnect_method': 'disconnectMethod',  # noqa: E501
        'enqueued_time': 'enqueuedTime',  # noqa: E501
        'call_timeout': 'callTimeout',  # noqa: E501
        'callback_timeout': 'callbackTimeout',  # noqa: E501
        'tag': 'tag',  # noqa: E501
        'answer_fallback_method': 'answerFallbackMethod',  # noqa: E501
        'answer_fallback_url': 'answerFallbackUrl',  # noqa: E501
        'disconnect_url': 'disconnectUrl',  # noqa: E501
        'username': 'username',  # noqa: E501
        'password': 'password',  # noqa: E501
        'fallback_username': 'fallbackUsername',  # noqa: E501
        'fallback_password': 'fallbackPassword',  # noqa: E501
        'priority': 'priority',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, application_id, account_id, call_id, to, _from, call_url, answer_method, answer_url, disconnect_method, *args, **kwargs):  # noqa: E501
        """CreateCallResponse - a model defined in OpenAPI

        Args:
            application_id (str): The id of the application associated with the `from` number.
            account_id (str): The bandwidth account ID associated with the call
            call_id (str): Programmable Voice API Call ID
            to (str): Recipient of the outgoing call
            _from (str): Phone number that created the outbound call
            call_url (str): The URL to update call state
            answer_method (CallbackMethodEnum):
            answer_url (str): URL to deliver the `answer` event webhook.
            disconnect_method (CallbackMethodEnum):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            enqueued_time (datetime, none_type): Time the call was accepted into the queue. [optional]  # noqa: E501
            call_timeout (float): The timeout (in seconds) for the callee to answer the call after it starts ringing.. [optional]  # noqa: E501
            callback_timeout (float): This is the timeout (in seconds) to use when delivering webhooks for the call.. [optional]  # noqa: E501
            tag (str, none_type): Custom tag value. [optional]  # noqa: E501
            answer_fallback_method (CallbackMethodEnum): [optional]  # noqa: E501
            answer_fallback_url (str, none_type): Fallback URL to deliver the `answer` event webhook.. [optional]  # noqa: E501
            disconnect_url (str, none_type): URL to deliver the `disconnect` event webhook.. [optional]  # noqa: E501
            username (str, none_type): Basic auth username.. [optional]  # noqa: E501
            password (str, none_type): Basic auth password.. [optional]  # noqa: E501
            fallback_username (str, none_type): Basic auth username.. [optional]  # noqa: E501
            fallback_password (str, none_type): Basic auth password.. [optional]  # noqa: E501
            priority (float, none_type): The priority of this call over other calls from your account.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.application_id = application_id
        self.account_id = account_id
        self.call_id = call_id
        self.to = to
        self._from = _from
        self.call_url = call_url
        self.answer_method = answer_method
        self.answer_url = answer_url
        self.disconnect_method = disconnect_method
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, application_id, account_id, call_id, to, _from, call_url, answer_method, answer_url, disconnect_method, *args, **kwargs):  # noqa: E501
        """CreateCallResponse - a model defined in OpenAPI

        Args:
            application_id (str): The id of the application associated with the `from` number.
            account_id (str): The bandwidth account ID associated with the call
            call_id (str): Programmable Voice API Call ID
            to (str): Recipient of the outgoing call
            _from (str): Phone number that created the outbound call
            call_url (str): The URL to update call state
            answer_method (CallbackMethodEnum):
            answer_url (str): URL to deliver the `answer` event webhook.
            disconnect_method (CallbackMethodEnum):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            enqueued_time (datetime, none_type): Time the call was accepted into the queue. [optional]  # noqa: E501
            call_timeout (float): The timeout (in seconds) for the callee to answer the call after it starts ringing.. [optional]  # noqa: E501
            callback_timeout (float): This is the timeout (in seconds) to use when delivering webhooks for the call.. [optional]  # noqa: E501
            tag (str, none_type): Custom tag value. [optional]  # noqa: E501
            answer_fallback_method (CallbackMethodEnum): [optional]  # noqa: E501
            answer_fallback_url (str, none_type): Fallback URL to deliver the `answer` event webhook.. [optional]  # noqa: E501
            disconnect_url (str, none_type): URL to deliver the `disconnect` event webhook.. [optional]  # noqa: E501
            username (str, none_type): Basic auth username.. [optional]  # noqa: E501
            password (str, none_type): Basic auth password.. [optional]  # noqa: E501
            fallback_username (str, none_type): Basic auth username.. [optional]  # noqa: E501
            fallback_password (str, none_type): Basic auth password.. [optional]  # noqa: E501
            priority (float, none_type): The priority of this call over other calls from your account.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.application_id = application_id
        self.account_id = account_id
        self.call_id = call_id
        self.to = to
        self._from = _from
        self.call_url = call_url
        self.answer_method = answer_method
        self.answer_url = answer_url
        self.disconnect_method = disconnect_method
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
